@echo off
rem  ###############################
rem  ####  Konfigurationsdatei  ####	V 1.2
rem  
rem  ACHTUNG: Die Parameter NICHT in Anfuehrungszeichen setzten!
rem  Auch dann nicht, wenn der Pfad Leerzeichen enthlt!

rem
rem  ACHTUNG: Variablen, die nur Pfade enthalten, mssen zwingend
rem  mit einem Backslash "\" ab abgeschlossen werden. Bei der 
rem  weiteren Verwendung dieser Variablen kann es sonst zu Problemen
rem  kommen und unversehbares Verhalten provozieren. 


rem ----------------------------------------------------------------
rem  ##########################
rem  ##                      ##
rem  ##  Basisverzeichnisse  ##
rem  ##  und Steuer-Skripte  ##
rem  ##                      ##
rem  ##########################


rem  %glob_basedir%
rem
rem  Basisverzeichnis - kann mit %~dp0 aus aktuellem Pfad, in 
rem  dem sich diese Konfigurationsdatei befindet, gesetzt werden

SET glob_basedir=%~dp0



rem  %glob_copy_backup_to%
rem
rem  Verzeichnis, das den Datenspiegel enthlt. Darunter befinden
rem  sich dann die einzelnen Verzeichnisse fr die zu sichernden
rem  Server. Die Server-Verzeichnisse werden von ROBOCOPY angelegt,
rem  mssen aber bei Bedarf manuell gelscht werden. z.B. wenn ein
rem  Server oder aber auch ein bisher gesicherter Share wegfllt.

SET glob_copy_backup_to=E:\Backup\



rem  %glob_backup_volume%
rem
rem  Laufwerksbuchstabe (mit ":") des Volumes, das den Datenspiegel enthlt 
rem  ( siehe %glob_copy_backup_to% )

SET glob_backup_volume=E:



rem  %glob_shadow_volume% 
rem
rem  Laufwerksbuchstabe (mit ":") des Volumes, das die Schattenkopien enthlt

SET glob_shadow_volume=F:


rem ----------------------------------------------------------------


rem ----------------------------------------------------------------
rem  #####################
rem  ##                 ##
rem  ##  Email-Versand  ##
rem  ##                 ##
rem  #####################


rem  %glob_mailserver%
rem
rem  SMTP-Mailserver (z.B. post.bayern.de)

SET glob_mailserver=post.bayern.de



rem  %glob_email_betreff%
rem
rem  Pseudo-Absender-Adresse; wird bentigt, damit der SMTP-Server die
rem  Email akzeptiert. Muss eine gltige Domain nach dem @ haben!

SET glob_email_betreff=Datenspiegelung %COMPUTERNAME%  %DATE% %TIME:~0,5% Uhr



rem  %glob_to_addr%
rem
rem  Empfnger der Email-Reports
rem  Es knnen auch mehrere Empfnger eingetragen werden.
rem  Siehe Hinweis unten!

SET glob_to_addr=torsten.hergesell@stbakru.bayern.de



rem  %glob_cc_addr%
rem
rem  Empfnger von Carbon-Copies der Email-Reports
rem  Es knnen auch mehrere Empfnger eingetragen werden.
rem  Siehe Hinweis unten!  
rem  Falls diese Option nicht gewnscht, einfach leer lassen

SET glob_cc_addr=



rem  %glob_from_addr%
rem
rem  Pseudo-Absender-Adresse; wird bentigt, damit der SMTP-Server die
rem  Email akzeptiert. Muss eine gltige Domain nach dem @ haben!

SET glob_from_addr=backuptest@stbakru.bayern.de



rem  !!! Hinweis !!!
rem
rem  Email an mehrere Empfnger mglich (getrennt durch Komma ohne Leerzeichen)
rem  z.B. glob_to_addr=torsten.hergesell@stbakru.bayern.de,iuk@stbakru.bayern.de
rem


rem ----------------------------------------------------------------


rem ----------------------------------------------------------------
rem  #######################
rem  ##                   ##
rem  ##  Datenspiegelung  ##
rem  ##                   ##
rem  #######################


rem  %glob_unc-paths%
rem
rem  Diese Datei enthlt eine Liste mit UNC-Pfaden zu den
rem  zu spiegelnden Server-Shares. z.B. \\Server\Share

SET glob_unc-paths=%glob_basedir%zu_sichernde_freigaben.txt


rem ----------------------------------------------------------------


rem ----------------------------------------------------------------
rem  ######################
rem  ##                  ##
rem  ##  Steuer-Skripte  ##
rem  ##                  ##
rem  ######################
rem


rem  %glob_cmd_datamirror%
rem
rem  Steuerskript, welches die Datenspiegelung durchfhrt

SET glob_cmd_datamirror=%glob_basedir%Shares_spiegeln\_shares_spiegeln.bat



rem  %glob_cmd_shadowcopy%
rem
rem  Steuerskript, welches die Schattenkopien anlegt und 
rem  gleichzeitig auch %glob_shadow_volume% verwaltet.

SET glob_cmd_shadowcopy=%glob_basedir%Schattenkopien\Schattenkopie.cmd



rem  %glob_cmd_sendemail%
rem
rem  Skript, das fr den Email-Versand zustndig ist

SET glob_cmd_sendemail=%glob_basedir%sende_Email\sende_email.cmd




rem ----------------------------------------------------------------


rem ----------------------------------------------------------------
rem  ###############################
rem  ##                           ##
rem  ##  Log- und Report-Dateien  ##
rem  ##                           ##
rem  ###############################
rem


rem  %glob_logdir%
rem
rem  Verzeichnis, wo die Logdateien hingeschrieben werden

SET glob_logdir=%glob_basedir%Logs\



rem  %glob_reportdir%
rem
rem  Diese Verzeichnis dient als "Container" fr alle Dateien,
rem  die im Anschluss an den Spiegelungs- und Sicherungsprozess
rem  per Email versandt werden sollen.

SET glob_reportdir=%glob_logdir%Report\



rem  %glob_report_archivdir%
rem
rem  In diesem Verzeichnis werden die Zip-Dateien archiviert, die
rem  zuvor per Mail versandt wurden.

SET glob_report_archivdir=%glob_logdir%Archiv



rem  %glob_completelog%
rem
rem  hier landen alle wichtigen Loginformationen der Datenspiegelung
rem  sowie der Schattenkopien, Email-Versand und sonstige Fehler
rem  Diese Datei wird nicht automatisch gelscht.

SET glob_completelog=%glob_logdir%datenspiegel_log.txt



rem  %glob_robo_errorlog%
rem
rem  Temporre Logdatei der Robocopy-Tasks. Dort werden alle
rem  Fehlermeldungen der Datenspiegelung mitgeloggt.
rem  Diese Datei wird nach Beendigung der Datenspiegelung gelscht

SET glob_robo_errorlog=zz_tmp_error.log



rem  %glob_all_robo_errors%
rem
rem  Reportdatei zum Sammeln aller Fehlermeldungen der einzelnen
rem  Robocopy-Tasks. Wird bentigt, um einen schnellen
rem  berblick ber Anzahl und Art der Fehler zu ermglichen.

SET glob_all_robo_errors=%glob_reportdir%fehlermeldungen.txt



rem  %glob_robo_statlog%
rem
rem  Temporre Logdatei der Robocopy-Tasks. Dort werden alle
rem  Statistiken (Anzahl, Gre der kopierten Dateien) fr eine
rem  sptere automatische Auswertung mitgeloggt.
rem  Diese Datei wird nach Beendigung der Datenspiegelung gelscht
rem

SET glob_robo_statlog=zz_tmp_rstats.log



rem  %glob_reportfile%
rem
rem  In dieser Datei landen alle Logdaten einer Datenspiegelung:
rem  Die Robocopy-Tasks schreiben ihre Statusmeldungen und Berichte
rem  hier hinein. Auerdem wird am Schluss noch %glob_robo_errorlog%
rem  angehngt.
rem  Diese Datei wird mit jeder neuen Spiegelung berschrieben.

SET glob_reportfile=%glob_reportdir%datenspiegelung_report.txt



rem  %glob_shadow_log%
rem
rem  In dieser Datei landen alle wichtigen Informationen ber die
rem  Schattenkopien. Diese Datei wird nicht automatisch gelscht!

SET glob_shadow_log=%glob_logdir%schattenkopien_log.txt



rem %glob_shadow_report%
rem
rem  Hier werden alle Informationen der letzten Schattenkopie 
rem  zusammengefasst und geloggt.
rem  Diese Datei wird mit jeder neuen Spiegelung berschrieben.

SET glob_shadow_report=%glob_reportdir%schattenkopie_report.txt



rem  %glob_cmd_datamirror_msg%
rem
rem  Status des Datenspiegelungs-Skripts. Der Text in dieser 
rem  Datei landet in der Email im Nachrichtentext.

SET glob_cmd_datamirror_msg=%glob_reportdir%msg_datenspiegel.txt



rem  %glob_cmd_shadowcopy_msg%
rem
rem  Status des Schattenkopie-Skripts. Der Text in dieser 
rem  Datei wird in den Nachrichtentext der ReportEmail ge-
rem  schrieben.

SET glob_cmd_shadowcopy_msg=%glob_reportdir%msg_schattenkopie.txt



rem  %glob_zipfile%
rem
rem

SET glob_zipfile=%glob_logdir%report%DATE%.zip

rem ----------------------------------------------------------------


rem ----------------------------------------------------------------
rem  ######################
rem  ##                  ##
rem  ##  Schattenkopien  ##
rem  ##                  ##
rem  ######################
rem

rem  %glob_exposedir%
rem
rem  Unter dem Verzeichnis %glob_exposedir% werden die Schattenkopien
rem  verfgbar gemacht. Dort werden Links (NTFS-Junctions) auf die
rem  einzelnen Schattenkopie-Snapshots angelegt.

SET glob_exposedir=%glob_shadow_volume%\ShadowRestore\


rem  %glob_free_percentage%
rem
rem  Die Variable %glob_free_percentage% gibt an, wieviel PROMILLE 
rem  von %glob_shadow_volume% als Reserve verfgbar sein muss. 
rem  Sollte vor dem Anlegen einer neuen Schattenkopie weniger Speicherplatz
rem  verfgbar sein, wird die lteste Schattenkopie gelscht.
rem  Als Wert darf nur eine Ganzzahl zwischen 1 und 999 stehen!
rem  (Empfehlung: glob_free_percentage=20 => 2,0%)

SET glob_free_percentage=20



rem  %glob_warn_percentage%
rem
rem  Sollten weniger als %glob_warn_percentage% Promille des Laufwerks
rem  frei sein, so wird eine Email mit einem Warnhinweis versandt.
rem  Als Wert darf nur eine Ganzzahl zwischen 1 und 999 stehen!
rem  (Empfehlung: glob_warn_percentage=10 => 1,0%)

SET glob_warn_percentage=10



rem  %glob_shadow_expose_log%
rem
rem  In SHADOW_EXPOSE_LOG werden beim Anlegen der Schattenkopien
rem  die Shadow-IDs zu den zugehrigen Verzeichnissen geloggt
rem  Diese Datei wird von CreateShadow.cmd beschrieben und ist dort
rem  hart kodiert (!)
rem  Diese Datei wird fr das automatisierte Lschen der Verzeichnisse
rem  bentigt, die nach dem Lschen der zugehrigen Schattenkopie brig
rem  bleiben.

SET glob_shadow_expose_log=%glob_basedir%Schattenkopien\shadow_main.txt


rem ----------------------------------------------------------------

rem  ##########################################################
rem  ## Sicherstellen, dass Variablenwerte zulssig sind
rem  ##
	if %glob_free_percentage% leq 0 (
		set glob_free_percentage=1
	)
	if %glob_free_percentage% geq 1000 (
		set glob_free_percentage=999
	)
	if %glob_warn_percentage% gtr %glob_free_percentage% (
		set glob_warn_percentage=%glob_free_percentage%
	)

rem ----------------------------------------------------------------
rem  #################################
rem  ##                             ##
rem  ##  Pfade zu bentigten Tools  ##
rem  ##      (EXE-Dateien)          ##
rem  ##                             ##
rem  #################################
rem

SET now_exe=%glob_basedir%Tools\now.exe

SET zip_exe=%glob_basedir%Tools\Zip.exe

SET robocopy_exe=C:\windows\system32\robocopy.exe

SET vshadow_exe=%glob_basedir%Tools\vshadow.exe


rem ----------------------------------------------------------------
rem  ######     Konfig Ende     ######
rem  #################################
