@echo off
rem #################################################################
rem
rem Skript zum Lschen von einzelnen Schattenkopien und deren 
rem Bereitstellungsverzeichnis in %glob_exposedir%
rem
rem Bentigter bergabeparameter:
rem
rem @param1 Bereitstellungsverzeichnis
rem
rem #################################################################

SET glob_konfig_bat=%~dp0..\konfig.bat

if exist %glob_konfig_bat% (
	call %glob_konfig_bat%
	cd %~dp0
) else (
	echo %glob_konfig_bat% nicht gefunden.
	goto :eof	
)

rem #################################
rem 
rem  die folgenden Variablen werden 
rem  aus KONFIG.BAT bentigt
rem
rem  %glob_shadow_volume% 
rem  %glob_shadow_log%
rem  %glob_exposedir%
rem  %glob_shadow_expose_log%
rem  %vshadow_exe%
rem
rem #################################<


setlocal

rem #########################################################################
rem # ab hier beginnt das Skript
rem #########################################################################
rem

echo.
set EXPOSEDIR=%1

rem
rem  Auswerten des bergabeparameters
rem


if not exist %EXPOSEDIR% (
	set EXPOSEDIR=%glob_exposedir%%EXPOSEDIR%
)

if not exist %EXPOSEDIR% (
	echo.
	echo FEHLER: %EXPOSEDIR% nicht vorhanden
	goto :eof
)


%vshadow_exe% -q | findstr /I %EXPOSEDIR% > nul

if /i %ERRORLEVEL% geq 1 (
	echo.
	echo FEHLER: %EXPOSEDIR% nicht verlinkt
	echo   keine zugehrge Schattenkopie gefunden 
	goto :eof
) else (
	echo - Schattenkopie verlinkt, ermittle Snapshot-ID
)


rem ############################################################################
rem
rem  Snapshot-ID aus Logdatei heraussuchen

set TEMPFILE=zz_tmp_snapshot-id.txt

findstr /I "%EXPOSEDIR%" %glob_shadow_expose_log% > %TEMPFILE%

if /i %ERRORLEVEL% gtr 0 (
	echo ! %glob_shadow_expose_log%: Snapshot-ID nicht vorhanden.
	echo - ermittele Snapshot-ID ueber Systemabfrage
	goto :SHID_by_systemquery
)
goto :SHID_by_file

rem
rem ###-------------------------------------------------###
rem
:SHID_by_systemquery

set TMP_DATA=zz_tmp_vsh-query.txt

%vshadow_exe% -q | findstr /n /v "@ABCXYZ" > %TMP_DATA%

for /f "delims=: tokens=1" %%a in ('findstr /I "%EXPOSEDIR%" %TMP_DATA%') do (
	set SEEKLINE=%%a
)

for /f "delims=: tokens=1,2" %%a in ('findstr "*" %TMP_DATA%') do (
	if /i %%a lss %SEEKLINE% set SHID=%%b
)

for /f "tokens=4" %%a in ('echo %SHID%') do (
	set SHID=%%a
)

echo %EXPOSEDIR% %SHID% > %TEMPFILE%

del %TMP_DATA%

rem
rem ###------------------------------------------------###
rem


:SHID_by_file

for /f "tokens=2" %%a in (%TEMPFILE%) do (
	set SHID=%%a
)

echo - SnapShot-ID: "%SHID%"

del %TEMPFILE%


rem ############################################################################
rem
rem  Speicherplatz vor dem Lschen ermitteln

set TEMPFILE=zz_tmp_diskfree.txt

fsutil volume diskfree %glob_shadow_volume% | findstr /n ":" > %TEMPFILE%

for /f "delims=: tokens=1,3 skip=1" %%a in (%TEMPFILE%) do (
	if %%a == 2 set VOLSPACE=%%b
	if %%a == 3 set VOLFREE_BEF=%%b
)
del %TEMPFILE%

rem "Rundung" auf Megabytes
set VOLSPACE=%VOLSPACE:~1,-6%
set VOLFREE_BEF=%VOLFREE_BEF:~1,-6%

echo - Speicherplatz: %VOLFREE_BEF% MB frei (von %VOLSPACE% MB)

rem ############################################################################
rem
rem  Snapshot lschen

echo - Loesche Snapshot

%vshadow_exe% -ds=%SHID%



rem ############################################################################
rem
rem  zugehriges Bereitstellungsverzeichnis lschen

echo - Loesche Bereitstellungsverzeichnis %EXPOSEDIR%

rmdir /s /q %EXPOSEDIR%


rem ############################################################################
rem
rem  Eintrag in der Logdatei %glob_shadow_expose_log% lschen  

echo - Loesche Eintrag in %glob_shadow_expose_log%

set TEMPFILE=zz_temp_shadowexposelog.txt

findstr /V "%SHID%" %glob_shadow_expose_log% > %TEMPFILE%
type %TEMPFILE% > %glob_shadow_expose_log%

del %TEMPFILE%


rem ############################################################################
rem
rem  Speicherplatz nach dem Lschen ermitteln

set TEMPFILE=zz_tmp_diskfree.txt

fsutil volume diskfree %glob_shadow_volume% | findstr /n ":" > %TEMPFILE%

for /f "delims=: tokens=1,3 skip=1" %%a in (%TEMPFILE%) do (
	if %%a == 3 set VOLFREE_AFT=%%b
)
del %TEMPFILE%

rem "Rundung" auf Megabytes
set VOLFREE_AFT=%VOLFREE_AFT:~1,-6%

echo - Speicherplatz: %VOLFREE_AFT% MB frei (von %VOLSPACE% MB)

rem ############################################################################
rem
rem  Freigegebenen Speicherplatz berechnen und ausgeben

SET /A SPACEGAIN=%VOLFREE_AFT% - %VOLFREE_BEF%

echo - freigegebener Speicherplatz: %SPACEGAIN% MB

rem ############################################################################
rem
rem  Vermerke manuelle Lschung in %glob_shadow_log%

echo.						>> %glob_shadow_log%
echo ----- 					>> %glob_shadow_log%
echo %DATE% %TIME% Schattenkopie lschen	>> %glob_shadow_log%
echo.						>> %glob_shadow_log%
echo - Snapshot ID "%SHID%" manuell gelscht	>> %glob_shadow_log%
echo - Bereitstellungsverzeichnis %EXPOSEDIR% gelscht >> %glob_shadow_log%
echo - freigegebener Speicherplatz auf %glob_shadow_volume% %SPACEGAIN% MB >> %glob_shadow_log%
echo.						>> %glob_shadow_log%
echo ----- 					>> %glob_shadow_log%
echo.						>> %glob_shadow_log%


rem ############################################################################
rem
rem


rem ############################################################################
rem
rem  

echo.

:eof
