@ECHO off

SET glob_konfig_bat=%~dp0..\konfig.bat

if exist %glob_konfig_bat% (
	call %glob_konfig_bat%
	cd %~dp0
) else (
	echo %glob_konfig_bat% nicht gefunden.
	goto :eof
)

rem #################################
rem 
rem  die folgenden Variablen werden 
rem  aus KONFIG.BAT bentigt
rem
rem  glob_unc-paths
rem  glob_copy_backup_to
rem  glob_mailserver
rem  glob_to_addr
rem  glob_from_addr
rem  glob_completelog
rem  glob_robo_errorlog
rem  glob_reportfile
rem  glob_robo_statlog
rem  glob_cmd_datamirror_msg
rem
rem #################################

set VERSION=1.2

set /a starttime=%time:~0,2%*3600+((1%time:~3,2%-100)*60)+(1%time:~6,2%-100)
set BEGINN=%DATE% %TIME:~0,8% Uhr

rem  ###################
rem  
rem  _shares_spiegeln.bat					Version: 1.2
rem  
rem  Mit _shares_spiegeln.bat lassen sich Windows-Freigaben auf eine Partition 
rem  bzw. in ein Verzeichnis spiegeln. In einer Textdatei sind die UNC-Pfade 
rem  der zu sichernden Freigaben einzutragen. Die Bezeichnung, bzw. den 
rem  Speicherort dieser Textdatei (im folgenden glob_unc-paths-Datei) laesst sich 
rem  ueber die, oberhalb dieser Beschreibung befindlichen Variable, glob_unc-paths 
rem  angeben. Der Speicherort der Sicherungen wird mit der Variable 
rem  copy_backp_to angegeben.
rem  
rem  Die angegebenen UNC-Pfade werden direkt auf den Speicherort abgebildet.
rem  
rem  Beispiel:
rem     UNC-Pfad: \\b-sv-server\foo$\bar
rem     Speicherort: D:\Backup\
rem     Von _shares_spiegeln.bat erzeugte Ordnerstruktur: 
rem       D:\Backup\b-sv-server\foo$\bar\
rem  
rem  Die Ordnertiefe eines UNC-Pfads darf die Anzahl von acht Unterordnern
rem  nicht ueberschreiten! Wie viele Unterordner die Freigabe enthaelt ist aber
rem  bedeutungslos. (Robocopy packt auch mehr als 255 Zeichen)
rem  Zur Verdeutlichung:
rem  So viele Elemente duerfen bei einem UNC-Pfad maximal angegeben werden:
rem  \\server0\ordner1\ordner2\ordner3\ordner4\ordner5\ordner6\ordner7\ordner8
rem  Ob nun unterhalb von ordner8 weiter Ordner liegen spielt bei der Durch-
rem  fuehrung der Sicherung keine Roll. Einzig, es kann dieser Unterordner 
rem  nicht explizit zur Sicherung angegeben werden.
rem  
rem  Beim Ausfuehren dieses Scripts werden bis zu vier parallele Kopier-
rem  instanzen, mit moeglist vier unterschiedlichen Servern erzeugt. 
rem  Auf Grund des "Protokollgeredes" (Es wird jede Datei einzeln vom Client 
rem  angevordert. Zwischen den dem Ende einer Uebertragung und der naechsten 
rem  Anvorderung entsteht eine Pause.) wird beim Uebertragen vieler relativ
rem  kleinen Dateien nicht die volle Netzwerkauslastung erreicht. Durch 
rem  parallelisierung wird der Durchsatz erhoeht. Sind kein unterschiedlichen 
rem  Server mehr vorhanden, werden auch mehrere Verbindungen zu einem Server 
rem  aufgebaut. (Volldynamisch)
rem  Die Reihenfolge der Server, wird durch ihr erstmaliges auftauchen in der 
rem  glob_unc-paths-Datei festgelegt. Die weitere Sortierung der UNC-Pfade ist 
rem  anschliessend nicht mehr relevant! Sprich: Wurde einmal mit der Sicherung 
rem  eines Servers begonnen, so werden nacheinander (oder parallel, wenn es 
rem  keine weiteren Server mehr neben ihm gibt) dessen Freigaben gesichert, 
rem  egal ob diese nun in der glob_unc-paths-Datei nach einander oder verstreute 
rem  auftauchen.
rem  
rem  Der Kopiervorgang selbst wird mit dem Microsoft Tool ROBOCOPY.EXE durch- 
rem  gefuehrt. Das Programm erzeugt dabei, fuer jede Sicherung eine eigene 
rem  Log-Datei. Diese traegt die Bezeichnung ROBOCOPY_LOG.txt und liegt einen 
rem  Ordner oberhalb der erzeugten Ordnerstruktur. Dem ersten Beispiel folgend,
rem  waere der Speicherort D:\Backup\b-sv-server\foo$\ROBOCOPY_LOG.txt
rem  Fuehren mehrere Sicherungen zur selben Logdatei, werden die Logdaten 
rem  jeweils angehaengt.
rem  Wer den Detailgrad der Logs aendern moechte, muss die entsprechenden 
rem  Parameter in der robocopy_task.bat direkt aendern.
rem  
rem  Folgende Dateien werden zur Ausfuherung benoetigt:
rem           (Muessen im selben Verzeichnis wie _shares_spiegeln.bat liegen.)
rem  robocopy_task.bat
rem  write_to_logfile.cmd
rem  
rem  Folgende Hilfsdateien werden zur Laufzeit temporaer erzeugt:
rem       (Muessen nach einem Systemabsturtz etc. vor dem naechsten ausfuehren 
rem        haendisch geloescht werden.)
rem  zz_tmp_serverlist1
rem  zz_tmp_serverlist2
rem  zz_tmp_unclist_tmp
rem  zz_tmp_usedshares
rem  zz_tmp_usedshare_found
rem  zz_tmp_robocopy_task_lock_1
rem  zz_tmp_robocopy_task_lock_2
rem  zz_tmp_robocopy_task_lock_3
rem  zz_tmp_robocopy_task_lock_4
rem  zz_tmp_ROBOCOPY_LOG1
rem  zz_tmp_ROBOCOPY_LOG2
rem  zz_tmp_ROBOCOPY_LOG3
rem  zz_tmp_ROBOCOPY_LOG4
rem  
rem  
rem  @author: thomas.bohl@stbakru.bayern.de
rem  co-author: torsten.hergesell@stbakru.bayern.de
rem  ###################





rem  ################################################
rem  ### Ab hier beginnt das eigentliche Programm ###
rem  ################################################





TITLE Shares spiegeln
ECHO Vorgang laeft an ...
ECHO.
ECHO.


SET tmp_logthis=zz_tmp_logfile.txt

echo -----------------------	> %glob_cmd_datamirror_msg%
echo ##  Datenspiegelung  ##	>> %glob_cmd_datamirror_msg%
echo.				>> %glob_cmd_datamirror_msg%

echo #############################################################	>%tmp_logthis%
echo Beginn der Datenspiegelung %DATE% %TIME:~0,8% - V %VERSION%	>>%tmp_logthis%
echo. 									>> %tmp_logthis%

TYPE %tmp_logthis% > %glob_reportfile%

echo %DATE% %TIME:~0,8% ### START Datenspiegelung >> %glob_completelog%
del %tmp_logthis%

if exist zz_tmp* (
	echo. 							>> %tmp_logthis%
	echo FEHLER: Es sind temporaere Dateien vorhanden:	>> %tmp_logthis%
	echo         %~dp0 					>> %tmp_logthis%
	echo. 							>> %tmp_logthis%
	echo Die letzte Datenspiegelung wurde nicht		>> %tmp_logthis%
	echo ordnungsgemaess beendet oder laeuft noch!		>> %tmp_logthis%
	echo.							>> %tmp_logthis%
	echo Falls ein Programmabsturz vorkam, muessen die	>> %tmp_logthis%
	echo temporaeren Dateien manuell geloescht werden!	>> %tmp_logthis%
	echo.							>> %tmp_logthis%
	echo Ordner: %~dp0					>> %tmp_logthis%
	echo ---						>> %tmp_logthis%
	TYPE %tmp_logthis% >> %glob_reportfile%
	TYPE %tmp_logthis% >> %glob_cmd_datamirror_msg%

	echo %DATE% %TIME:~0,8% #!# FEHLER: Temporre Dateien vorhanden! Skript abgebrochen >> %glob_completelog%

	TYPE %tmp_logthis%
	call :sleep 5
	goto :eof
)


rem  
rem  Hilfsvariablen NICHT editieren
rem  

SET hostname=""
SET /A server_counter=0
SET /A used_server_counter=0
SET /A share_counter=0
SET /A help_var1=0
SET help_var2=--slot-closed--
SET server-slot1=--slot-closed--
SET server-slot2=--slot-closed--
SET server-slot3=--slot-closed--
SET server-slot4=--slot-closed--
SET share-slot1=--slot-open--
SET share-slot2=--slot-open--
SET share-slot3=--slot-open--
SET share-slot4=--slot-open--
SET skip_first=true





rem  
rem  Pruefen ob die notwendigen Dateien vorhanden sind
rem  

IF NOT EXIST %glob_unc-paths% (

	ECHO Die Konfigurationsdatei %glob_unc-paths% ist nicht vorhanden!
	CALL :sleep 5
	GOTO eof
)

IF NOT EXIST %glob_copy_backup_to% (

	ECHO Das Datensicherungsverzeichnis %glob_copy_backup_to% wurde nicht gefunden!
	CALL :sleep 5
	GOTO eof
)

IF NOT EXIST %robocopy_exe% (

	ECHO Im Verzeichnis wurde keine robocopy.exe gefunden!
	CALL :sleep 5
	GOTO eof
)

IF NOT EXIST robocopy_task.bat (

	ECHO Im Verzeichnis wurde keine robocopy_task.bat gefunden!
	CALL :sleep 5
	GOTO eof

)

IF NOT EXIST %glob_copy_backup_to% md %glob_copy_backup_to%



ECHO laeuft


rem  
rem  Lese Hostnamen aus der UNC-Liste
rem  

FOR /f "delims=\" %%z IN ('type %glob_unc-paths%') DO (

	ECHO %%z >> zz_tmp_serverlist1
)

rem  
rem  Entferne doppelte Hostnamen aus Serverliste
rem  

IF EXIST zz_tmp_serverlist1 (

	FOR /f %%z IN (zz_tmp_serverlist1) DO (
	
		CALL :save_unique_hostname %%z
	)
) ELSE (

	ECHO Es sind keine zu sichernden Freigaben angegeben.
	CALL :sleep 5
	GOTO quit
)


rem  
rem  Anzahl der Freigaben zaehlen
rem  

FOR /f %%z IN ('type %glob_unc-paths%') DO (

	SET /A share_counter += 1
)


rem  
rem  Robocopy-Logs lschen
rem  

echo.
echo ------------------------------------------------
echo  Alte Robocopy-Logs (ROBOCOPY_LOG.txt) loeschen 

for /f "tokens=1,2,3,4,5,6,7,8,9 delims=\" %%a in (%glob_unc-paths%) do (

	IF EXIST "%glob_copy_backup_to%\%%a\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\ROBOCOPY_LOG.txt"
	IF EXIST "%glob_copy_backup_to%\%%a\%%b\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\%%b\ROBOCOPY_LOG.txt"
	IF EXIST "%glob_copy_backup_to%\%%a\%%b\%%c\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\%%b\%%c\ROBOCOPY_LOG.txt"
	IF EXIST "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\ROBOCOPY_LOG.txt"
	IF EXIST "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\ROBOCOPY_LOG.txt"
	IF EXIST "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\%%f\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\%%f\ROBOCOPY_LOG.txt"
	IF EXIST "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\ROBOCOPY_LOG.txt"
	IF EXIST "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h\ROBOCOPY_LOG.txt" DEL "%glob_copy_backup_to%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h\ROBOCOPY_LOG.txt"

)
echo ------------------------------------------------
echo.

rem  
rem  Alle Dateien im Reportverzeichnnis lschen
rem  

DEL /Q "%glob_reportdir%*.*"


rem  Erst Inizialisierung
rem  Server-Slots mit Hostnamen befuellen
rem  

CALL :get_next_host
SET server-slot1=%help_var2%

CALL :get_next_host
SET server-slot2=%help_var2%

CALL :get_next_host
SET server-slot3=%help_var2%

CALL :get_next_host
SET server-slot4=%help_var2%





rem  
rem  Freie Share-Slots mit UNC-Pfaden befuellen 
rem  und entsprechende Robocopyinstanz starten.
rem  Herzstueck der Anwendung ;-)
rem  

:slot1
SET help_var3=--slot-open--

IF %share-slot1% == --slot-open-- (

	IF NOT %server-slot1% == --slot-closed-- (
	
		CALL :get_next_share %server-slot1%
		CALL :check_share_status %server-slot1%
		CALL :set_new_hostname_-_server1
	
	) ELSE (
	
		IF NOT %server-slot2% == --slot-closed-- (
		
			CALL :get_next_share %server-slot2%
			CALL :check_share_status %server-slot2%
			CALL :set_new_hostname_-_server2
		
		) ELSE (
		
			IF NOT %server-slot3% == --slot-closed-- (
			
				CALL :get_next_share %server-slot3%
				CALL :check_share_status %server-slot3%
				CALL :set_new_hostname_-_server3
			
			) ELSE (
			
				IF NOT %server-slot4% == --slot-closed-- (
				
					CALL :get_next_share %server-slot4%
					CALL :check_share_status %server-slot4%
					CALL :set_new_hostname_-_server4
				)
			)
		)
	)
)
SET share-slot1=%help_var3%

IF %share-slot1% == --renew-slot-- (

	SET share-slot1=--slot-open--
	GOTO slot1
)

IF NOT %share-slot1% == --slot-open-- IF NOT EXIST zz_tmp_robocopy_task_lock_1 (

	START /B robocopy_task.bat 1 %share-slot1% %glob_copy_backup_to%
	CALL :sleep 1
)


:slot2
SET help_var3=--slot-open--

IF %share-slot2% == --slot-open-- (

	IF NOT %server-slot2% == --slot-closed-- (
	
		CALL :get_next_share %server-slot2%
		CALL :check_share_status %server-slot2%
		CALL :set_new_hostname_-_server2
	
	) ELSE (
	
		IF NOT %server-slot2% == --slot-closed-- (
		
			CALL :get_next_share %server-slot3%
			CALL :check_share_status %server-slot3%
			CALL :set_new_hostname_-_server3
		
		) ELSE (
		
			IF NOT %server-slot4% == --slot-closed-- (
			
				CALL :get_next_share %server-slot4%
				CALL :check_share_status %server-slot4%
				CALL :set_new_hostname_-_server4
			
			) ELSE (
			
				IF NOT %server-slot1% == --slot-closed-- (
				
					CALL :get_next_share %server-slot1%
					CALL :check_share_status %server-slot1%
					CALL :set_new_hostname_-_server1
				)
			)
		)
	)	
)
SET share-slot2=%help_var3%

IF %share-slot2% == --renew-slot-- (

	SET share-slot2=--slot-open--
	GOTO slot2
)

IF NOT %share-slot2% == --slot-open-- IF NOT EXIST zz_tmp_robocopy_task_lock_2 (

	START /B robocopy_task.bat 2 %share-slot2% %glob_copy_backup_to%
	CALL :sleep 1
)


:slot3
SET help_var3=--slot-open--

IF %share-slot3% == --slot-open-- (

	IF NOT %server-slot3% == --slot-closed-- (
	
		CALL :get_next_share %server-slot3%
		CALL :check_share_status %server-slot3%
		CALL :set_new_hostname_-_server3
	
	) ELSE (
	
		IF NOT %server-slot4% == --slot-closed-- (
		
			CALL :get_next_share %server-slot4%
			CALL :check_share_status %server-slot4%
			CALL :set_new_hostname_-_server4
		
		) ELSE (
		
			IF NOT %server-slot1% == --slot-closed-- (
			
				CALL :get_next_share %server-slot1%
				CALL :check_share_status %server-slot1%
				CALL :set_new_hostname_-_server1
			
			) ELSE (
			
				IF NOT %server-slot3% == --slot-closed-- (
				
					CALL :get_next_share %server-slot3%
					CALL :check_share_status %server-slot3%
					CALL :set_new_hostname_-_server3
				)
			)
		)
	)	
)
SET share-slot3=%help_var3%

IF %share-slot3% == --renew-slot-- (

	SET share-slot3=--slot-open--
	GOTO slot3
)

IF NOT %share-slot3% == --slot-open-- IF NOT EXIST zz_tmp_robocopy_task_lock_3 (

	START /B robocopy_task.bat 3 %share-slot3% %glob_copy_backup_to%
	CALL :sleep 1
)


:slot4
SET help_var3=--slot-open--

IF %share-slot4% == --slot-open-- (

	IF NOT %server-slot4% == --slot-closed-- (
	
		CALL :get_next_share %server-slot4%
		CALL :check_share_status %server-slot4%
		CALL :set_new_hostname_-_server4
	
	) ELSE (
	
		IF NOT %server-slot1% == --slot-closed-- (
		
			CALL :get_next_share %server-slot1%
			CALL :check_share_status %server-slot1%
			CALL :set_new_hostname_-_server1
		
		) ELSE (
		
			IF NOT %server-slot2% == --slot-closed-- (
			
				CALL :get_next_share %server-slot2%
				CALL :check_share_status %server-slot2%
				CALL :set_new_hostname_-_server2
			
			) ELSE (
			
				IF NOT %server-slot3% == --slot-closed-- (
				
					CALL :get_next_share %server-slot3%
					CALL :check_share_status %server-slot3%
					CALL :set_new_hostname_-_server3
				)
			)
		)
	)	
)
SET share-slot4=%help_var3%

IF %share-slot4% == --renew-slot-- (

	SET share-slot4=--slot-open--
	GOTO slot4
)

IF NOT %share-slot4% == --slot-open-- IF NOT EXIST zz_tmp_robocopy_task_lock_4 (

	START /B robocopy_task.bat 4 %share-slot4% %glob_copy_backup_to%
	CALL :sleep 1
)





rem  
rem  Wenn alle share-slot* gleich "--slot-open--" sind 
rem  und keine zz_tmp_robocopy_task_lock_*-Dateien mehr existieren,
rem  wird das Programm beendet.
rem  

IF %share-slot1% == --slot-open-- IF %share-slot2% == --slot-open-- (
	
	IF %share-slot3% == --slot-open-- IF %share-slot4% == --slot-open-- (
	
		IF NOT EXIST zz_tmp_robocopy_task_lock_* (
		
			GOTO quit
		)
	)
)





rem  
rem  Alle 3 Sekunden puefen ob ein Task beendet wurde
rem  Wenn ein Robocopy_Task beendet ist, share-slot wieder freigeben
rem
rem  Sollte man wirklich sehr sehr viele kleine Shares sichern wollen, 
rem  ist es sinnvoll, diesen Wert auf 1 zu setzen.
rem  

CALL :sleep 3

IF NOT EXIST zz_tmp_robocopy_task_lock_1 SET share-slot1=--slot-open--
IF NOT EXIST zz_tmp_robocopy_task_lock_2 SET share-slot2=--slot-open--
IF NOT EXIST zz_tmp_robocopy_task_lock_3 SET share-slot3=--slot-open--
IF NOT EXIST zz_tmp_robocopy_task_lock_4 SET share-slot4=--slot-open--

GOTO slot1










rem  ###################################
rem  ### Ab hier folgen die Methoden ###
rem  ###################################





rem  
rem  Mit dieser Methode werden die verschiedenen
rem  Hostnamen in der Datei zz_tmp_serverlist2 gespeichert.
rem  Doppelte Eintrge werden verhindert.
rem  
rem @param %1 Servername
:save_unique_hostname

SET still_in_the_list=false

IF EXIST zz_tmp_serverlist2 (

	FOR /f %%z IN (zz_tmp_serverlist2) DO (
	
		IF /I %1 == %%z SET still_in_the_list=true
	)
	
)

IF %still_in_the_list% == false (

	ECHO %1 >> zz_tmp_serverlist2
	SET /A server_counter += 1
)

SET hostname=%1
GOTO eof





rem  
rem  Liefert bei jedem Aufruf den jeweils nchsten Hostname aus der, 
rem  (zuvor automatisch erstellten) Liste aller Server.
rem  Ist das Dateiende erreicht wird "--slot-closed--" zurueck gegeben.
rem  
rem @return %help_var2%
:get_next_host

SET /A help_var1=0
IF NOT %server_counter% LEQ %used_server_counter% (

	FOR /f %%z IN (zz_tmp_serverlist2) DO (
	
		CALL :get_next_host_-_check_counters %%z
	)
	SET /A used_server_counter += 1

) ELSE (

	SET help_var2=--slot-closed--

)
GOTO eof

rem  
rem  Ist die Hilfsvaribale und used_server_counter 
rem  gleich, ist der richtige Servername gefunden.
rem  

:get_next_host_-_check_counters
IF %help_var1% EQU %used_server_counter% (

	SET help_var2=%1
	
)
SET /A help_var1 += 1
GOTO eof





rem  
rem  Liefert fuer einen bestimmten (uebergebenen) Server den
rem  jeweils naechsten UNC-Pfad zurueck. Sind fuer einen
rem  Server keine weiteren Shares vorhanden wird "--slot-open--"
rem  zurueck geliefert.
rem  
rem @param %1 Servername
rem @return %help_var3%
:get_next_share

SET skip_first=true

FIND "%1" %glob_unc-paths% > zz_tmp_unclist_tmp

rem
rem  Das "delims"-Zeichen sorgt dafr, dass Dateinamen mit Leerzeichen
rem  nicht getrennt und somit sauber verarbeitet werden.
rem 

FOR /f "delims=^" %%z IN (zz_tmp_unclist_tmp) DO (
	CALL :get_next_share_realy "%%z"

)
GOTO eof

:get_next_share_realy
SET /A zz_tmp_usedshare_found_lines = 0

rem  
rem  Die erste Zeile grundsaetzlich ueberspringen. Der Befehl 
rem  FIND schreibt in die erste Zeile leider den Dateinamen.
rem  

IF %skip_first% == false (

	IF %help_var3% == --slot-open-- (
	
		rem  Nachsehen ob Zeile bereits in der Liste 
		rem  der abgearbeiteten Shares drin steht.
		rem  Wenn nicht, %share-slot1% zuweisen
		
		IF EXIST zz_tmp_usedshares (
		
			FIND %1 zz_tmp_usedshares > zz_tmp_usedshare_found
			
			FOR /f "delims=^" %%z IN (zz_tmp_usedshare_found) DO SET /A zz_tmp_usedshare_found_lines += 1
			
			CALL :get_next_share_-_check_lines %1
		
		) ELSE (
		
			SET help_var3=%1
		)
	)
) ELSE (

	SET skip_first=false

)
GOTO eof

:get_next_share_-_check_lines
IF %zz_tmp_usedshare_found_lines% LSS 2 (

	SET help_var3=%1

)
GOTO eof





rem  
rem  Prueft ob bei einem zuvor gesetzten Share-Slot "--slot-open--"
rem  zurueck geliefert wurde. Ist dies zutreffend wird ein neuer
rem  Server angefordert.
rem  
rem @param %1 Servername
rem @return %help_var3%
:check_share_status

SET help_var4=false
SET help_var2=%1

IF %help_var3% == --slot-open-- (

	SET help_var4=true
	
	CALL :get_next_host
)

IF NOT %help_var2% == --slot-closed-- IF %help_var4% == true (

	SET help_var3=--renew-slot--

)
GOTO eof





rem  
rem  Hilfsmethoden zum setzten der server-slot*-
rem  Variablen innenrhalb von Methoden (Batch Bloedsinn)
rem  Wird benoetigt wenn sich mit CALL :check_share_status
rem  ein neuer Hostname ergeben hat.
rem  

:set_new_hostname_-_server1
SET server-slot1=%help_var2%
GOTO eof

:set_new_hostname_-_server2
SET server-slot2=%help_var2%
GOTO eof

:set_new_hostname_-_server3
SET server-slot3=%help_var2%
GOTO eof

:set_new_hostname_-_server4
SET server-slot4=%help_var2%
GOTO eof





rem  
rem  Sleep-Funktion mit TIMEOUT-Befehl oder ping emulieren :-)
rem  
rem @param %1 Sekunden
:sleep
TIMEOUT /T %1 /NOBREAK > nul
rem SET /A seconds = %1 + 1
rem ping localhost -n %seconds% > nul
GOTO eof



rem  ------------------  
rem  Ende und Aufrumen
rem  ------------------

:quit

rem  ###############
rem  Laufzeitmessung


set /a endtime=%time:~0,2%*3600+((1%time:~3,2%-100)*60)+(1%time:~6,2%-100)
set /a timediff=%endtime%-%starttime%
if %timediff% lss 0 (set /a timediff=%timediff%+86400)

set /a zzSTD=%timediff% / 3600
set /a zzMIN=%timediff% %% 3600 / 60
set /a zzSEK=%timediff% %% 3600 %% 60

if %zzSTD% lss 10 (set zzSTD=0%zzSTD%)
if %zzMIN% lss 10 (set zzMIN=0%zzMIN%)
if %zzSEK% lss 10 (set zzSEK=0%zzSEK%)

set timediff=%zzSTD%:%zzMIN%:%zzSEK%
rem  ###############


echo Ende der Datenspiegelung %DATE% %TIME:~0,8%  (Dauer: %timediff%)		>> %glob_reportfile%
echo ############################################################# 		>> %glob_reportfile%
echo. 										>> %glob_reportfile%

echo %DATE% %TIME:~0,8% ### ENDE der Datenspiegelung (Dauer: %timediff% )	>> %glob_completelog%


rem  #---------------------------------------------------------#
rem  # Fehlermeldungen der ROBOCOPY-Tasks an den Report hngen #
rem  #---------------------------------------------------------#

echo. >> %glob_reportfile%
Type %glob_robo_errorlog% >> %glob_reportfile%


rem
rem  Anzahl der Fehlermeldungen ermitteln
rem

findstr "FEHLER.[0-9]" %glob_reportfile%		>> %glob_all_robo_errors%

echo ###!!!---ENDE---!!!###				>> %glob_all_robo_errors%

for /f "delims=:" %%a IN ('findstr /N "###!!!---ENDE---!!!###" %glob_all_robo_errors%') do (
	set anzahl=%%a
)
set /a anzahl=anzahl-1
echo Anzahl: %anzahl%

if %anzahl% LEQ 0 (
	set anzahl=keine
	del %glob_all_robo_errors%
)

echo.
echo -------------------------------
echo Datenspiegel: %anzahl% Fehler beim Kopieren
echo -------------------------------
echo.

rem
rem --- Ausrechnen der Gesamtstatistik fr diese Datenspiegelung
rem
rem <INPUT>

rem ###############################################################################
rem
rem  Statistik in Message-Datei schreiben %glob_cmd_datamirror_msg%
rem

echo ##################################	>> %glob_cmd_datamirror_msg%
echo Datenspiegelung abgeschlossen!	>> %glob_cmd_datamirror_msg%
echo.					>> %glob_cmd_datamirror_msg%
echo Hostname: %COMPUTERNAME%		>> %glob_cmd_datamirror_msg%
echo.					>> %glob_cmd_datamirror_msg%
echo Beginn: %BEGINN%			>> %glob_cmd_datamirror_msg%
echo   Ende: %DATE% %TIME:~0,8% Uhr	>> %glob_cmd_datamirror_msg%
echo  Dauer: %timediff%			>> %glob_cmd_datamirror_msg%
echo ##################################	>> %glob_cmd_datamirror_msg%

echo Datenspiegelung abgeschlossen (Dauer: %timediff%)

echo.										>> %glob_cmd_datamirror_msg%
echo Anzahl der RoboCopy-Fehlermeldungen bei der Datenspiegelung: %anzahl%	>> %glob_cmd_datamirror_msg%
echo.										>> %glob_cmd_datamirror_msg%
echo Folgende Shares wurden gespiegelt: 					>> %glob_cmd_datamirror_msg%
echo.										>> %glob_cmd_datamirror_msg%
type %glob_robo_statlog%							>> %glob_cmd_datamirror_msg%
echo.										>> %glob_cmd_datamirror_msg%




rem  
rem  Hilfsdateien entfernen
rem  

IF EXIST %tmp_logthis% DEL %tmp_logthis%
IF EXIST %glob_robo_errorlog% DEL %glob_robo_errorlog%
IF EXIST zz_tmp_* DEL zz_tmp_*



rem
rem wegen der besseren Debug-Mglichkeiten, sollte kein EXIT-Befehl
rem verwendet werden. Das Skript sollte also per CALL aufgerufen werden!

rem EXIT





:eof
