@echo off
rem  ########################################################################
rem
rem  Kleines Hilfsprogramm zum Schreiben von Logdaten (mit TYPE)
rem
rem  Durch das parallele Ausfhren mehrerer Tasks ist nicht zu
rem  jeder Zeit Schreibzugriff auf eine Logdatei sicher gestellt. 

rem  Falls whrend eines versuchten Schreibvorgangs die Logdatei
rem  von einem anderen Task geffnet ist, bricht der Schreibvorgang 
rem  ab. In diesem Falle wrden keine Informationen geloggt.
rem
rem  Eine Schleife stellt sicher, dass alles geloggt werden kann.
rem
rem  Der Schreibzugriff wird durch eine lck-Datei angezeigt.

rem @param %1 Datei, welche die Log-Daten enthlt 
rem @param %2 Datei, in die die Log-Daten geschrieben werden sollen 

cd %~dp0 

setlocal
set SOURCEFILE=%1
set DESTINATION=%2

if not exist %SOURCEFILE% goto :eof

 
set WRITE_LOCK=%DESTINATION: =_%
set WRITE_LOCK=%WRITE_LOCK:\=_%
set WRITE_LOCK=%WRITE_LOCK::=_%.lck

rem echo test >> ..\%WRITE_LOCK%

rem
rem  Endlosschleife vermeiden:
rem  Timeout in Sekunden

set TIMEOUT=10

for /L %%i in (1,1,%TIMEOUT%) do (
	if not exist %WRITE_LOCK% goto :no_write_lock
	echo %DESTINATION% file locked! Try %%i of %TIMEOUT%
	TIMEOUT /T 1 /NOBREAK > nul
	SET FILE_WAS_LOCKED=%%i
)


rem
rem  Trotz Timeout sicherstellen, dass die LogInformation irgendwo hingeschrieben wird.
rem  Es wird versucht ein Dumpfile in %glob_basedir% zu beschreiben.
rem

echo %DATE% %TIME:~0,8% %DESTINATION% was locked for %FILE_WAS_LOCKED% seconds >> %glob_completelog%

if /i "%FILE_WAS_LOCKED%" equ "%TIMEOUT%" (
		echo %DESTINATION% was locked; dumping log information...
		echo Log information was written to %glob_basedir%dumplog.txt	>> %glob_completelog%
		echo.								>> %glob_basedir%dumplog.txt
		echo -----------------------------------			>> %glob_basedir%dumplog.txt
		echo %DATE% %TIME% 						>> %glob_basedir%dumplog.txt
		TYPE %1 							>> %glob_basedir%dumplog.txt
		echo ----------------------------------- 			>> %glob_basedir%dumplog.txt
		goto :eof
)

:no_write_lock

rem 
rem Filelock setzten und Logfile schreiben 
rem

echo lock > %WRITE_LOCK%
TYPE %1 >> %2

rem echo %DATE% %TIME% %DESTINATION% %FILE_WAS_LOCKED% >> %glob_logdir%writelog.txt

DEL %WRITE_LOCK%

:eof
