@echo off
rem #################################################################
rem
rem  Skript zum Versenden von Emails
rem
rem  Es werden drei Parameter ausgewertet, Reihenfolge beachten!
rem
rem  param%1 :	Betreffzeile der Email
rem		Dieser Parameter ist zwingend erforderlich!
rem
rem  param%2 :	Textdatei, die als Nachrichtentext angezeigt wird.
rem		Dieser Parameter ist zwingend erforderlich!
rem
rem  param%3 :	Datei wird als an die Email als Attachment angehngt.
rem		Dieser Parameter kann entfallen.
rem
rem #################################################################
setlocal

SET glob_konfig_bat=%~dp0..\konfig.bat

if exist %glob_konfig_bat% (
	call %glob_konfig_bat%
	cd %~dp0
) else (
	echo %glob_konfig_bat% nicht gefunden.
	goto :eof	
)

rem #################################
rem 
rem  die folgenden Variablen werden 
rem  aus KONFIG.BAT bentigt
rem
rem  %glob_mailserver%
rem  %glob_to_addr%
rem  %glob_cc_addr% 
rem  %glob_from_addr%
rem  %glob_basedir%
rem  %glob_logdir%
rem  %glob_completelog%
rem
rem #################################




set MAIL_EXE=%glob_basedir%Tools\blat.exe


rem #################################
rem # ab hier beginnt das Skript
rem #########################################################################
rem
rem  bergebene Parameter prfen

set MAIL_SUBJECT=%~1

set MAIL_TEXTFILE=%2

set MAIL_ATTACH=%3


if "%MAIL_SUBJECT%" == "" (	
	echo Kein Betreff angegeben!
	goto :eof
) 


if "%MAIL_TEXTFILE%" == "" (	
	echo Kein Nachrichtentext angegeben!
	goto :eof
) 

if not exist %MAIL_TEXTFILE% (
	echo Datei "%MAIL_TEXTFILE%" nicht gefunden!
	goto :eof
)


if "%MAIL_ATTACH%" == "" (	
	rem echo DEBUG Kein Anhang angegeben!
	set ATTACH= 
) else (
	rem echo DEBUG Anhang ist %MAIL_ATTACH%
	set ATTACH=%MAIL_ATTACH%
)



rem #########################################################################

set SMTPSERVER=-server %glob_mailserver%

set FROM=-f %glob_from_addr%

set TO=-t %glob_to_addr%

set SUBJECT=-subject "%MAIL_SUBJECT%"

if exist %ATTACH% set ATTACH=-attach %ATTACH%

if not "%glob_cc_addr%" == "" set CC=-cc %glob_cc_addr%

set temp_err_msg=%~dp0Status_letzter_Emailversand.txt

%MAIL_EXE% %MAIL_TEXTFILE% %SMTPSERVER% %SUBJECT% %TO% %FROM% %CC% %ATTACH% -debug > %temp_err_msg%
if errorlevel 1 (
	echo %DATE% %TIME:~0,8% Email: FEHLER beim Versenden! siehe %temp_err_msg% >> %glob_completelog%
	echo.				>> %temp_err_msg%
	echo Skriptvariablen:		>> %temp_err_msg%
	echo -----		 	>> %temp_err_msg%
	echo    from: %glob_from_addr%	>> %temp_err_msg%
	echo      to: %glob_to_addr%	>> %temp_err_msg%
	echo      cc: %glob_cc_addr%	>> %temp_err_msg%
	echo    subj: %MAIL_SUBJECT%	>> %temp_err_msg%
	echo  attach: %MAIL_ATTACH%	>> %temp_err_msg%
	echo  server: %glob_mailserver%	>> %temp_err_msg%
	echo ----- 			>> %temp_err_msg%
) else (
	echo %DATE% %TIME:~0,8% Email: "%glob_to_addr%" "%MAIL_SUBJECT%" >> %glob_completelog%
)

rem #########################################################################

:eof
